import { curry2 } from './curry2';
import { curry3 } from './curry3';
import { curry4 } from './curry4';
import { curry5 } from './curry5';
import { curryN } from '../curryN';
/**
 * Given a function it returns a curried version of that function.
 * @name curry(fn: Fuction): CurriedFunction
 */
export var curry = function curry(fn) {
    switch (fn.length) {
        case 0:
            return fn;
        case 1:
            return fn;
        case 2:
            return curry2(fn);
        case 3:
            return curry3(fn);
        case 4:
            return curry4(fn);
        case 5:
            return curry5(fn);
        default:
            return curryN(fn.length, fn);
    }
};
//# sourceMappingURL=curry.js.map