"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var curry2_1 = require("./curry2");
var curry3_1 = require("./curry3");
var curry4_1 = require("./curry4");
function curry5(fn) {
    function curried(a, b, c, d, e) {
        var args = [];
        for (var _i = 5; _i < arguments.length; _i++) {
            args[_i - 5] = arguments[_i];
        }
        switch (arguments.length) {
            case 1:
                return curry4_1.curry4(function (b, c, d, e) { return fn(a, b, c, d, e); });
            case 2:
                return curry3_1.curry3(function (c, d, e) { return fn(a, b, c, d, e); });
            case 3:
                return curry2_1.curry2(function (d, e) { return fn(a, b, c, d, e); });
            case 4:
                return function (e) {
                    var args = [];
                    for (var _i = 1; _i < arguments.length; _i++) {
                        args[_i - 1] = arguments[_i];
                    }
                    return fn.apply(void 0, [a, b, c, d, e].concat(args));
                };
            default:
                return fn.apply(void 0, [a, b, c, d, e].concat(args));
        }
    }
    return curried;
}
exports.curry5 = curry5;
//# sourceMappingURL=curry5.js.map